Subject: Re: [PATCH net-next v6 0/4] net: netconsole: convert to NBCON console infrastructure

From: Breno Leitao <[email-masked]>
Date: Fri, 6 Feb 2026 04:10:49 -0800

On Thu, Feb 05, 2026 at 12:12:52AM +0106, John Ogness wrote:
> On 2026-02-03, Breno Leitao <[email-masked]> wrote:
> > This series adds support for the nbcon (new buffer console) infrastructure
> > to netconsole, enabling lock-free, priority-based console operations that
> > are safer in crash scenarios.
> >
> > The implementation is introduced in three steps:
> >
> > 0) Extend printk to expose CPU and taskname (task->comm) where the
> >    printk originated from. (Thanks John and Petr for the support in
> >    getting this done)
> > 1) Refactor the message fragmentation logic into a reusable helper function
> > 2) Extend nbcon support to non-extended (basic) consoles using the same
> >    infrastructure.
> >
> > The initial discussion about it appeared a while ago in [1], in order to
> > solve Mike's HARDIRQ-safe -> HARDIRQ-unsafe lock order warning, and the root
> > cause is that some hosts were calling IRQ unsafe locks from inside console
> > lock.
> >
> > At that time, we didn't have the CON_NBCON_ATOMIC_UNSAFE yet. John
> > kindly implemented CON_NBCON_ATOMIC_UNSAFE in 187de7c212e5 ("printk:
> > nbcon: Allow unsafe write_atomic() for panic"), and now we can
> > implement netconsole on top of nbcon.
> >
> > Important to note that netconsole continues to call netpoll and the
> > network TX helpers with interrupt disable, given the TX are called with
> > target_list_lock.
> >
> > Netdev maintainers, Petr suggested that this patchset goes through netdev[2]
> >
> > Link: https://lore.kernel.org/all/b2qps3uywhmjaym4mht2wpxul4yqtuuayeoq4iv4k3zf5wdgh3@tocu6c7mj4lt/ [1]
> > Link: https://lore.kernel.org/all/[email-masked]/ [2]
> >
> > Signed-off-by: Breno Leitao <[email-masked]>
> >
> > ---
> > Changes in v6:
> > - Do not select PRINTK_EXECUTION_CTX in NETCONSOLE_DYNAMIC (Jakub)
> > - Do not make PRINTK_EXECUTION_CTX user visible (Jakub)
> 
> I am really sorry, but I failed to communicate what I meant about
> introducing the CONSOLE_HAS_EXECUTION_CTX symbol.
> 
> As Jakub mentioned, NETCONSOLE_DYNAMIC should just directly select
> PRINTK_EXECUTION_CTX and get rid of the CONSOLE_HAS_EXECUTION_CTX symbol
> (like you had in v1).

Ack! Let me update it.

Thanks for the clarification,
--breno